import SDL;

import std.string;

class MySDL {
	static SDL_Surface*
	createRGBSurface(Uint32 flags, Uint32 w, Uint32 h, Uint32 bpp) {
		return SDL_CreateRGBSurface(flags, w, h, bpp, 0,0,0,0);
	}

	static void
	blitSurface(SDL_Surface* src, int sx, int sy, int sw, int sh,
					  SDL_Surface* dst, int dx, int dy) {
		SDL_Rect srcRect, dstRect;
		srcRect.x = sx; srcRect.y = sy; srcRect.w = sw; srcRect.h = sh;
		dstRect.x = dx; dstRect.y = dy;
		SDL_BlitSurface(src, &srcRect, dst, &dstRect);
	}

	static void
	blitSurface(SDL_Surface* src, SDL_Surface* dst, int x, int y) {
		SDL_Rect dstRect;
		dstRect.x = x; dstRect.y = y;
		SDL_BlitSurface(src, (SDL_Rect*)0, dst, &dstRect);
	}

	static void blitSurface(SDL_Surface* src, SDL_Surface* dst) {
		SDL_BlitSurface(src, (SDL_Rect*)0, dst, (SDL_Rect*)0);
	}

	static void setColorKey(SDL_Surface* surf, Uint32 flags,
							Uint8 r, Uint8 g, Uint8 b) {
		SDL_SetColorKey(surf, flags, SDL_MapRGB(surf.format, r, g, b));
	}

	static SDL_Surface* displayFormat(SDL_Surface* src) {
		SDL_Surface* dst = SDL_DisplayFormat(src);
		SDL_FreeSurface(src);
		return dst;
	}

	static SDL_Surface* loadBMP(char[] file) {
		return displayFormat(SDL_LoadBMP(toStringz(file)));
	}

	static SDL_Color color(Uint8 r, Uint8 g, Uint8 b) {
		SDL_Color ret;
		ret.r = r;
		ret.g = g;
		ret.b = b;
		return ret;
	}

	static void changeColor(SDL_Surface* surf, Uint32 to) {
		Uint8* p = (Uint8*)surf.pixels;
		for (int j = 0; j < surf.h; j++) {
			for (int i = 0; i < surf.w; i++) {
				if (*p) *p = to;
				p++;
			}
			p += surf.pitch - surf.w;
		}
	}
}
