import SDL;

import log;
import mysdl;
import game;

import std.random;
import std.date;

class Submarine {
public:
	this() {	
		Log.info("init");
		initSDL();
		initMisc();
		Log.info("init success");
	}

	~this() {
		Log.info("quit");

		SDL_Quit();

		Log.info("quit success");
	}

	void initSDL() {
		if (SDL_Init(SDL_INIT_VIDEO) < 0) {
			Log.errorSDL("Couldn't init SDL");
			exit(1);
		}

		scr_ = SDL_SetVideoMode(640, 480, 8, SDL_SWSURFACE);
		if (scr_ == (SDL_Surface*)0) {
			Log.errorSDL("Couldn't set video mode");
			exit(1);
		}

	}

	void initMisc() {
		rand_seed(getUTCtime(), 0);
	}

	void run() {
		bit end = false;
		while (!end) {
			auto Game game = new Game(scr_);
			game.run();
			end = game.isEnd();
		}
	}

private:
	SDL_Surface* scr_;
}

int main() {
	auto Submarine submarine = new Submarine;
	submarine.run();

	return 0;
}
